<?php
// $Id: stats.inc,v 1.1.2.1 2010/08/27 23:19:45 tomdude48 Exp $
function kwresearch_word_popularity($keywords, &$msgs, $params = array()) {
  
  //$apiret = kwresearch_wordtracker_get_words_popularity($keywords, $errmsg, null, $type,$include_misspellings,$include_plurals,$adult_filter);
  
  // make api calls
  $sources = module_invoke_all('kwresearch_sources');
  foreach ($sources AS $aid => $source) {
    $data[$aid] = call_user_func($source['search_volume_callback'], $keywords, $msgs, $params[$aid]);  
  }

  $ret = array();
  if(!empty($data)) {
    foreach($data AS $s => $d) {
      if(!empty($d)) {
        foreach($d AS $k => $c) {
          if(!$ret[$k]) {
            $ret[$k] = array(
              'term' => $k,
              $s . '_count' => $c,
            );
          }
          else {
            $ret[$k][$s . '_count'] = $c;
          }
        }
      }
    }
    // calculate total count
    $d = count($sources);
    foreach($ret AS $k => $v) {
      $a = 0;
      foreach($sources AS $aid => $s) {
        $a += $s['search_volume_ratio'] * $v[$aid . '_count'];
      }
      $ret[$k]['_count'] = $a / $d;
    }
    uasort($ret, 'kwresearch_count_sort');
  }

  $ret = kwresearch_save_keyword_record_stats($ret, $params);
  
  return $ret;
}
// see $params['pid']
function kwresearch_save_keyword_record_stats($keywords_data, $params) {
  if(is_array($keywords_data)) {
    foreach($keywords_data AS $k => $data) {      
      if($params['pid']) {
        $sql = '
          SELECT k.*, pk.priority AS page_priority 
          FROM {kwresearch_keyword} k
          LEFT JOIN {kwresearch_page_keyword} pk ON pk.kid=k.kid AND nid=%d
          WHERE keyword = "%s"
        ';
        $r = db_fetch_object(db_query($sql, $params['pid'], $data['term']));      
      }
      else {
        $sql = '
          SELECT k.*
          FROM {kwresearch_keyword} k
          WHERE keyword = "%s"
        ';
        $r = db_fetch_object(db_query($sql, $data['term']));
      }
      if($r) {
        $keywords_data[$k]['kid'] = $r->kid;
        $keywords_data[$k]['priority'] = $r->priority;
        $keywords_data[$k]['value'] = $r->value;
        $keywords_data[$k]['page_priority'] = $r->page_priority;
        $keywords_data[$k]['page_count'] = $r->page_count;
        $sql = '
          UPDATE {kwresearch_keyword}
          SET 
            stats_update = %d,
            daily_volume = %d          
          WHERE keyword = "%s"
        ';
        db_query($sql, time(), $data['_count'], $data['term']);
      }
      else {
        $keywords_data[$k]['priority'] = NULL;
        $keywords_data[$k]['value'] = NULL;
        $sql = '
          INSERT INTO {kwresearch_keyword}
          (keyword, word_count, stats_update, daily_volume)
          VALUES ("%s", %d, %d, %d)
        ';
        db_query($sql, $data['term'], str_word_count($data['term']), time(), $data['_count']);
        $keywords_data[$k]['kid'] = db_last_insert_id('kwresearch_keywords', 'kid');
      }
    }
  }
  return $keywords_data;
}

/*
* $type = all|embedded|exact (from WordTracker API)
*/ 
function kwresearch_wordtracker_get_words_popularity($keywords, &$msgs, $params) {

  $connection = ($params['connection'])?$params['connection']:NULL;
  $type = ($params['type'])?$params['type']:NULL;
  $include_misspellings = ($params['include_misspellings'])?$params['include_misspellings']:NULL;
  $include_plurals = ($params['include_plurals'])?$params['include_plurals']:NULL;
  $adult_filter = ($params['adult_filter'])?$params['adult_filter']:NULL;
  $limit = ($params['limit'])?$params['limit']:NULL;

  if(is_null($include_misspellings)) {
    $include_misspellings = variable_get('kwresearch_include_misspellings', FALSE);
  }
  if(is_null($include_plurals)) {
    $include_plurals = variable_get('kwresearch_include_plurals', TRUE);
  }
  if(is_null($adult_filter)) {
    $adult_filter = variable_get('kwresearch_adult_filter', 'remove_dubious');
  }
//print "include_plurals=$include_plurals, adult_filter=$adult_filter";
  if(!$type) {
    $type = 'all';
  }
  if(strpos($type, '_words_popularity')) { // type is full callabv
    $call = 'get_'.$type;
    $callabv = $type;  
  }
  else if($type) {
    $call = 'get_'.$type.'_words_popularity';
    $callabv = $type.'_words_popularity';
  }
  
  if(!is_array($keywords)) {    
    $keywords_arr = explode(',',$keywords);
    foreach($keywords_arr AS $i => $kw) {
      $keywords_arr[$i] = trim($kw);
    }
  }
  else {
    $keywords_arr = $keywords;
    $keywords = implode(',', $keywords);
  }
  if(!$limit) {
    if($perms = variable_get('kwresearch_api_perms','')) {
      $limit = $perms[$call]['result_limit'];
    }
    if(!$limit) { 
      $limit = 15; 
    }
  }
  
  $last_cache = variable_get('kwresearch_last_cache',0);
  $cachecheck = FALSE;
  if((time - $last_cache) > KWANALYSIS_CACHE_TIMEOUT) {
    $cachecheck = TRUE;
  }
  
  $sql = '
    SELECT *
    FROM {kwresearch_wordtracker_data}
    WHERE 
    keyphrase = "%s" AND
    include_misspellings = %d AND
    include_plurals = %d AND
    adult_filter = %d
  ';
//printf($sql,$keywords,$include_misspellings,$include_plurals,$adult_filter);
  // translate adult filter to index
  $afv = kwresearch_get_adult_filter_values();
  $afi = array_search($adult_filter, $afv);
  $dbresult = db_fetch_array(db_query($sql,$keywords,$include_misspellings,$include_plurals,$afi));
//print_r($dbresult);
  if($dbresult[$callabv] && ($dbresult[$callabv."_limit"] >= $limit)) {
    $dbret = unserialize($dbresult[$callabv]);
    if(!$cachecheck) {
      return array_slice($dbret, 0, $limit);   
    }    
  }  

  if(!$connection) {
    if(!$connection = kwresearch_get_xml_connect()) {
      $msg = t('The API key is not set. To get full reporting <a href="!url" target="settings">set the api key in settings</a>',
        array(
          '!url' => base_path() . 'admin/settings/kwresearch'
        )
      );
      $msgs[] = kwresearch_format_message($msg, 'error');
      return FALSE;
    }  
  }
  if($connection['l10seoapi_call']) {
    $apiret = xmlrpc(
      $connection['endpoint'],
      $connection['l10seoapi_call'],
      $call,
      $connection['apikey'],
      $keywords_arr,
      'case_folded',
      (bool)$include_misspellings,
      (bool)$include_plurals,
      $adult_filter,
      $limit,
      15
    );  
  }
  else {
    $apiret = xmlrpc(
      $connection['endpoint'],
      $call,
      $connection['apikey'],
      $keywords_arr,
      'case_folded',
      (bool)$include_misspellings,
      (bool)$include_plurals,
      $adult_filter,
      $limit,
      15
    );
  }

  if ($error = xmlrpc_error()) {
    if ($error->code <= 0) {
      $error->message = t('Outgoing HTTP request to %endpoint failed because the socket could not be opened.', array('%endpoint' => $endpoint));
    }
    $errmsg = t('Could not get wordtracker keyword popularity because the remote site gave an error: %message (@code)', 
      array(
        '%message' => $error->message,
        '@code' => $error->code,
      )
    );
    $msgs[] = kwresearch_format_message($errmsg, 'error');
    return FALSE;
  }
  
  if (!is_array($apiret)) {
      $errmsg = t('Expected return of type array, but got [@type]', array('@type' => gettype($apiret)));
      $msgs[] = kwresearch_format_message($errmsg, 'error');
      return FALSE;
  }

//dsm($apiret);

  if(!$dbresult) {
    $sql = '
      INSERT INTO {kwresearch_wordtracker_data}
      (keyphrase, include_misspellings, include_plurals, adult_filter, ' . $callabv . ', ' . $callabv . '_limit)
      VALUES ("%s",%d,%d,%d,"%s",%d)
    ';
    $afv = kwresearch_get_adult_filter_values();
    $afi = array_search($adult_filter, $afv);
    $query = db_query($sql,$keywords,$include_misspellings,$include_plurals,$afi,serialize($apiret),$limit);
  } else if(!$dbret) {
    $sql = '
      UPDATE {kwresearch_wordtracker_data}
      SET 
        ' . $callabv . ' = "%s",
        ' . $callabv . '_limit = %d
      WHERE 
        keyphrase = "%s" AND
        include_misspellings = %d AND
        include_plurals = %d AND
        adult_filter = %d
    ';
    $afv = kwresearch_get_adult_filter_values();
    $afi = array_search($adult_filter, $afv);
    $query = db_query($sql,$afi,serialize($apiret), $limit, $keywords, '', $include_misspellings, $include_plurals, $afi);
  } else if(array_slice($dbret,0,10) != array_slice($apiret,0,10)) { // empty cache, it is out of date
    $sql = '
      DELETE FROM {kwresearch_wordtracker_data}
    ';
    $query = db_query($sql);
    drupal_set_message(t('Keyword cache reset.'));
    variable_set('kwresearch_last_cache',time());
  }  
  return $apiret;
}

function kwresearch_api_query_permissions() {

  if(!$c = kwresearch_get_xml_connect()) {
    drupal_set_message(t('API key is missing.'),'error'); 
  }
  $call = 'query_permissions';
  if($c['l10seoapi_call']) {
    $apiret = xmlrpc(
      $c['endpoint'],
      'l10seoapi.wordtracker_user',
      $call,
      $c['apikey']
    );    
  }
  else {
    $apiret = xmlrpc(
      $c['endpoint'],
      $call,
      $c['apikey']
    );   
  }
  
  return $apiret;
}

/**
 *  Implentation of hook_contentanalysis_analyzers()
 *  register contentanalysisexample with contentanalysis analyzers registry
 */

function kwresearch_kwresearch_sources() {
  $sources['wordtracker'] = array(
    'title' => t('Wordtracker'),
    'module' => 'kwresearch',
    'search_volume_callback' => 'kwresearch_wordtracker_get_words_popularity',
    'search_volume_ratio' => 1.7636, // ratio = total daily searches / count from data
    'search_volume_report_columns' => array(
      'wordtracker_count' => t('Wordtracker count')
    ),
    'search_volume_report_values_callback' => 'kwresearch_kwresearch_format_search_volume_value',
  );
  return $sources;  
}

function kwresearch_kwresearch_get_search_volume($keywords, $params = NULL) {
  list($keyword) = explode(',', $keywords);
  $keyword = stripslashes($keyword);
  
  $info = scribeseo_get_keyword_alternates($keyword);
  
  $keywordAlternates = $info['GetKeywordAlternatesResult']['AlternateKeywords']['Keyword'];

  $apiret = array();
  foreach ($keywordAlternates as $alternate) {
    $apiret[strtolower($alternate['Term'])] = $alternate['AnnualSearchVolume'];
  }
  
  return $apiret;
}

function kwresearch_kwresearch_format_search_volume_value($values, $keyword='', $type = 'term') {
  switch($type) {
    case 'wordtracker_count':
      if($values['wordtracker_count'] > 0) {
        $output = ($values['wordtracker_count']=='NA') ? 'NA': number_format($values['wordtracker_count']);
      }
      else {
        $output = $values['wordtracker_count'];
      }
      break;
    default:
      return FALSE;
  }  
  return $output;
}

function kwresearch_get_xml_connect() { 
  $c = array();
  $c['apikey'] = variable_get('kwresearch_apikey','');
  if(!$c['apikey']) {
    $c['apikey'] = variable_get('levelten_apikey','');
  }
  if(!$c['apikey']) {
    return FALSE;
  }
  if(substr($c['apikey'], 0, 8) == 'levelten') {
    $c['endpoint'] = 'http://www.leveltendesign.com/xmlrpc.php';
    $c['l10seoapi_call'] = 'l10seoapi.wordtracker';
  }
  else {
    $c['endpoint'] = 'http://xmlrpc.wordtracker.com';
  }
  return $c;
}

function kwresearch_wordtracker_ping() {
  $url = 'http://test.xmlrpc.wordtracker.com';
  $call = 'ping';
  $apikey = 'guest';

         
  if (!$apiret = xmlrpc($url, $call, $apikey)) {
      print 'Procedure returned error message: ' . $client->getErrorMessage() . '.';
  }
  if ($apiret !== true) {
      print 'The procedure returned an incorrect result.';
  }
  print 'Successfully pinged test account.';
}